{ }
(*
	ARMenuToolBar V1.0 by Albert Research 98

	Legal Notice:

	Distribution

	This component is freeware. As such, Albert Research gives no warranty to its accuracy, fitness for any particular use, effects of use, or reliability.
	This component may not be distributed as a part of another component package without Albert Research written consent. It may be freely distributed,
	although it must be distributed with all original files in their original format intact. If you use this component in your software, please include an acknow-
	ledgment that portions are copyrighted by Albert Research. Please contact the author, Albert, at one of the below address with questions, comments, bug-reports
	 or any updates you make to the component.

	 Albert Research:

	 e-mail: albertrs@redestb.es
	 Web: http://personal.redestb.es/albertrs



								 ``     ```''MM'``
										``A##NNN````
								   `` ``''#UUMMMNN```
								 ``  'MMAAHRRMMMHHNN```
								   ``R@@##@##MMHHHMMN````
								 ``HHR@@@@@##MMMHHNNNNN``
							  ```AAHH#@@@@@@@MMNNNMMMHHNN`           `
				  ``       `````H##@@H####@##MMMMMHHMHHHHH```` ````
						 `` ''###@@##HHHHHR##MMNNNMMNHHHHNNN`````  ``
				  ```      `UU###@@HH@##RR#RRMMMHHNNNNNMMHHHNN`````  `
						 ``#####@##@@@@@##@##MMMMMNNNHHNNNNNNNN````
					   ````RHH##H#####@@@@@##NNNNNMMMNNNNNNNHHHNN  ``
					   `````''~~~::UU@##RR#RRMMMMMNNMMMMM'''```````
					`##HHHH@HH@@HHHHHHHHNNH@@NNHHH@@HHHHH@##HH#@@##HH`
      `````        ````'####@@###@@H@@HHH@@HHHHHHH@HH@@@@@@@@@@NNMNNHHHHH``
		``     ```##@@@@@##@@@##@@@@@@####@##MMMMMMMNMMMMNMMHHMHHNNNNHNN```
		  `  ```''RR#HH@@@@HRR##@@@@@@@@@@@##MMMNNMMNNNNNNHHMMNNNMMHHNNNHH```  `
		  `    `HHAA@####@@@@@@@H@@@@@@@#####MMNNNMMNNNNNMNNHHNMMNNMMHNNNN'       ``
	  ``   ``  ```''~MM####@HH##@@@@@@@@##@##MMNNNMMNNNNNNNNHHMNNNNMM'''`````  `
	 `    ```##HHH@@@HHHHHHHNNHHHHH@@@@@#####MMMMMMMNNNNN@HH@@@HHHH##H##HHRHHHH```
	  ````M##@@@@@@@@@@@@HHHHHHHHHHHHHHHHHHHH@@H@@@@HHHHHHHH@@@HHNNNNMHHMMNNNHHH````
	  ``''#@@@@@HH@@@@@@@@@@@@@@@HHHHHHHHHHHH@@HHHHHH@@HH@HHNNMMMNNNNHMMHHNNNNNNMM```
      ```MMRR@##@@@@@@@@@@@@HHHHH@@@@@@@@@@@@HHHHH@@@NNMNNMMMMMNNNNNMMMMNMMMMHNNNNMNNNN`
      ''~AA##@##@@H@@@@@@@@@@@@@@@@@@@@@@@@@@@##MMMNNMMNNNMMNNNMMMNNNNNNNNNMMNNNMMNNNNNH
      ~~A@@RRRHHHH#@@@@@@@@@@@@@@@@@@@@@@@@###RRMMMNNHHHNNMMNNNNNNMMMMNNHNNNNNMMHHMNNNNN@@
      ``'@@##@RR##H@@@@@@@####@##@@@@@@@@@@###@@MMMMMMMNNNHHNNNNNNNNNNNNNNNMMHNNNNHMMHH```
		  ```''M####@##HH##H@@HH#@@HH@HHHH#@@NNNNNNNNNNNNMMMNNNMMNNMMNHHNNN`````  ``
		   ```````MMRRRRR@@#HH@@@##HHH@@HHRRRMMMNNNNMNNNNNMMNNNMMNNHHHNN`````
      ```    ```       `````''R####A@@###HH@@@##MMNMMNNMNNHHNHHNNN``````     `
		   ``               ```````##R@@@@@@@HHMNNNNHNN```       ``
	  ``                         ``'''MMAA#RRMMNHHMM`````          ``   ``
										   ``''     `

*)
{ }

{V1.0... Initial Release}

{$DEFINE ENGLISH}
//{$DEFINE SPANISH}
unit ARMenuToolBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Buttons,extctrls,comctrls,imglist,dsgnintf,stdctrls;

type
	TARMenuToolBar = class;

	TARMenuPages = class;

	TARMenuItems = class;

	TAboutProperty = class(TPropertyEditor)
		public
			procedure Edit; override;
			function GetAttributes: TPropertyAttributes; override;
			function GetValue: string; override;
		end;
	

	{Each Single PageItem  at the Collection}
	TARMenuPage = class (TCollectionItem)
		private
			{ Private declarations }
			V_Owner: TARMenuPages;
			V_MenuCaption: string;
			V_MenuFont: TFont;
			V_MenuColor: TColor;
			V_MenuCaptionBeginColor: TColor;
			V_MenuCaptionEndColor: TColor;
			V_MenuGradientWidth: integer;
			V_MenuStripColor: TColor;


			{Page Strip}
			V_PageArea : TPanel;
			V_PageButton: TSpeedButton;
			V_PageButtonFlat: boolean;
			V_MenuStripHeight: integer;
			V_PageButtonSpacing: integer;
			V_PageButtonLayout: TButtonLayout;
			V_PageButtonEnabled: boolean;
			V_PageButtonHint: string;
			V_PageButtonShowHint: boolean;
			V_PageButtonParentShowHint : boolean;
			V_PageButtonCursor: TCursor;

			V_ImageIndex: integer;

			{MenuItems}
			V_ARMenuItems: TARMenuItems;

			{Events}


			{Internal Object Events}
			procedure V_PageAreaOnResize(Sender: TObject);
			procedure V_OnPageButtonClick(Sender: TObject);
			procedure PSetV_ARMenuItems(const Value: TARMenuItems);
			procedure PSetV_MenuFont(const Value: TFont);
			procedure PSetV_MenuColor(const Value: TColor);
			procedure PSetV_MenuCaptionBeginColor(const Value: TColor);
			procedure PSetV_MenuCaptionEndColor(const Value: TColor);
			procedure PSetV_MenuGradientWidth(const Value: integer);
			procedure PSetV_MenuStripHeight(const Value: integer);
			procedure PSetV_ImageIndex(const Value: integer);
			procedure PSetV_PageButtonLayout(const Value: TButtonLayout);
			procedure PSetV_PageButtonSpacing(const Value: integer);
			procedure PSetV_PageButtonHint(const Value: string);
			procedure PSetV_PageButtonEnabled(const Value: boolean);
			procedure PSetV_PageButtonParentShowHint(const Value: boolean);
			procedure PSetV_PageButtonShowHint(const Value: boolean);
			procedure PSetV_MenuCaption(const Value: string);
			procedure PSetV_PageButtonFlat(const Value: boolean);
			procedure V_OnMenuFontChange(Sender: TObject);
			procedure PSetV_PageButtonCursor(const Value: TCursor);
			procedure PSetV_MenuStripColor(const Value: TColor);


		protected
			{ Protected declarations }
			procedure DefineProperties(Filer: TFiler); override;
			function  GetDisplayName: string; override;
		public
			{ Public declarations }
			constructor Create(Collection: TCollection); override;
			destructor Destroy; override;
			procedure Assign(Source: TPersistent); override;
		published
			{ Published declarations }
			property MenuCaption: string read V_MenuCaption write PSetV_MenuCaption;
			property PageButtonFlat: boolean read V_PageButtonFlat write PSetV_PageButtonFlat;
			property PageButtonLayout: TButtonLayout read V_PageButtonLayout write PSetV_PageButtonLayout;
			property PageButtonSpacing: integer read V_PageButtonSpacing write PSetV_PageButtonSpacing;
			property MenuItems: TARMenuItems read V_ARMenuItems write PSetV_ARMenuItems;
			property MenuFont: TFont read V_MenuFont write PSetV_MenuFont;
			property MenuColor: TColor read V_MenuColor write PSetV_MenuColor;
			property MenuCaptionBeginColor: TColor read V_MenuCaptionBeginColor write PSetV_MenuCaptionBeginColor;
			property MenuCaptionEndColor: TColor read V_MenuCaptionEndColor write PSetV_MenuCaptionEndColor;
			property MenuGradientWidth: integer read V_MenuGradientWidth write PSetV_MenuGradientWidth;
			property MenuStripHeight: integer read V_MenuStripHeight write PSetV_MenuStripHeight;
			property MenuStripColor: TColor read V_MenuStripColor write PSetV_MenuStripColor;			
			property ImageIndex: integer read V_ImageIndex write PSetV_ImageIndex;
			property Enabled: boolean read V_PageButtonEnabled write PSetV_PageButtonEnabled;
			property PageButtonHint: string read V_PageButtonHint write PSetV_PageButtonHint;
			property PageButtonShowHint: boolean read V_PageButtonShowHint write PSetV_PageButtonShowHint;
			property PageButtonParentShowHint: boolean read V_PageButtonParentShowHint write PSetV_PageButtonParentShowHint;
			property Cursor: TCursor read V_PageButtonCursor write PSetV_PageButtonCursor;

	end;

	{The Collection that groups the individual MenuPages}
	TARMenuPages = class (TCollection)
		private
			{ Private declarations }
			V_Owner : TARMenuToolBar;


			function GetItem(Index: Integer): TARMenuPage;
			procedure SetItem(Index: Integer; Value: TARMenuPage);

		protected
			{ Protected declarations }
			function GetOwner: TPersistent; override;
			procedure Update(Item: TCollectionItem); override;
		public
			{ Public declarations }
			constructor Create(AOwner: TARMenuToolBar);
			destructor Destroy; override;
			function Add : TARMenuPage;
			property ARMenuToolBar: TARMenuToolBar read V_Owner;
			property Items[Index: Integer]: TARMenuPage read GetItem write SetItem; default;
		published
			{ Published declarations }
		end;

	{Each Single MenuItem at the Collection}

	TARMenuItem = class (TCollectionItem)
		private
			{ Private declarations }
			V_Owner: TARMenuItems;
			V_ItemCaption: string;
			V_OnMenuItemClick: TNotifyEvent;
			V_OnMenuItemDblClick: TNotifyEvent;
			V_CloseMenuOnAction: boolean;
			V_ImageIndex : integer;
			V_StateIndex: integer;
			V_ItemEnabled: boolean;
			procedure PSetV_ItemCaption(const Value: string);
			procedure PSetV_CloseMenuOnAction(const Value: boolean);
			procedure PSetV_ImageIndex(const Value: integer);
			procedure PSetV_ItemEnabled(const Value: boolean);
			procedure PSetV_StateIndex(const Value: integer);

		protected
			{ Protected declarations }
			procedure DefineProperties(Filer: TFiler); override;
			function  GetDisplayName: string; override;
		public
			{ Public declarations }
			constructor Create(Collection: TCollection); override;
			destructor Destroy; override;
			procedure Assign(Source: TPersistent); override;
		published
			{ Published declarations }
			property ItemCaption: string read V_ItemCaption write PSetV_ItemCaption;
			property CloseMenuOnAction: boolean read V_CloseMenuOnAction write PSetV_CloseMenuOnAction;
			property ImageIndex: integer read V_ImageIndex write PSetV_ImageIndex;
			property StateIndex: integer read V_StateIndex write PSetV_StateIndex;
			property OnClick: TNotifyEvent read V_OnMenuItemClick write V_OnMenuItemClick;
			property OnDblClick: TNotifyEvent read V_OnMenuItemDblClick write V_OnMenuItemDblClick;
			property ItemEnabled: boolean read V_ItemEnabled write PSetV_ItemEnabled;
	end;

	{The Collection that groups the individual MenuItems}
	TARMenuItems = class (TCollection)
		private
			{ Private declarations }
			V_Owner : TARMenuPage;

			function GetItem(Index: Integer): TARMenuItem;
			procedure SetItem(Index: Integer; Value: TARMenuItem);

		protected
			{ Protected declarations }
			function GetOwner: TPersistent; override;
			procedure Update(Item: TCollectionItem); override;
		public
			{ Public declarations }
			constructor Create(AOwner: TARMenuPage);
			destructor Destroy; override;
			function Add : TARMenuItem;
			property ARMenuPage: TARMenuPage read V_Owner;
			property Items[Index: Integer]: TARMenuItem read GetItem write SetItem; default;
		published
			{ Published declarations }

		end;
                                       
	TARMenuStatus = (men_Closed,men_Opened);
	TARMenuViewStyleAction = (arvs_AlwaysDefault,arvs_RememberLast);
	TARLTV_Sort = (sort_Desc,sort_Asc,sort_NoSort);
	TARMenuPopupPosition = (pop_Left,Pop_Right,pop_Top,pop_Bottom);


	TARMenuToolBar = class(TPanel)
		private
			{ Private declarations }
			V_MenuPages : TARMenuPages;
			V_MenuStatus: TARMenuStatus;
			V_ActiveMenuIndex: integer;
			V_ARMenuToolBarWidth: integer;
			V_DefMenuViewStyle: TViewStyle;
			V_DefaultApplied : boolean;
			V_MenuViewStyleAction: TARMenuViewStyleAction;
			V_MenuAreaWidthOpened: integer;
			V_MenuAreaHeightOpened: integer;
			V_LTV_Sort: TARLTV_Sort;
			V_SortToogle: boolean;
			V_About: TAboutProperty;
			V_Owner: TWinControl;
			V_OwnerIsForm: boolean;
			V_MenuAnimation: boolean;
			V_MenuOpenAnimationSteps: integer;
			V_MenuCloseAnimationSteps: integer;
			V_MenuPopUpPosition: TARMenuPopupPosition;
			V_ButtonAreaColor: TColor;

			{ToolCaption}
			V_ToolCaptionHeight: integer;
			V_ToolCaptionBevelInner: TPanelBevel;
			V_ToolCaptionBevelOuter: TPanelBevel;
			V_ToolCaptionBevelWidth: integer;
			V_ToolCaptionBorderStyle: TBorderStyle;
			V_ToolCaptionBorderWidth: integer;
			V_ToolCaptionColor: TColor;
			V_ToolCaptionCaption: string;
			V_ToolCaptionAlignment: TAlignment;
			V_ToolCaptionFont: TFont;

			{ToolImage}
			V_ToolImageStretch: boolean;
			V_ToolImageHeight: integer;
			V_ToolImageTransparent: boolean;
			V_ToolImagePicture: TPicture;
			V_ToolImageCenter: boolean;
			V_ToolImageVisible : boolean;

			{Internal Objects}
			V_ToolCaption: TPanel;
			V_ButtonArea: TPanel;
			V_MenuArea: TPanel;
			V_MenuCaption: TImage;
			V_CaptionPanel: TPanel;
			V_CloseButton: TSpeedButton;
			V_LTV_MenuItems: TListView;
			V_LTV_MenuItemsColumn : TListColumn;
			V_ListButton : TSpeedButton;
			V_ReportButton : TSpeedButton;
			V_Iconbutton: TSpeedButton;
			V_SmallIconButton: TSpeedButton;
			{ImageList for the ToolBar}
			V_ImageList: TImageList;
			{ImageLists for the MenuItems ListView}
			V_MenuSmallImages: TImageList;
			V_MenuLargeImages: TImageList;
			V_MenuStateImages: TImageList;

			{ToolImage}
			V_ToolImagePanel: TPanel;
			V_ToolImage: TImage;

			{internal functions and procedures}
			procedure GradientFill(V_DestinationImage : TImage ; V_BeginColor: TColor; V_EndColor: TColor; V_GradientWidth: integer);
			procedure CloseMenu;
			procedure OpenMenu;
			procedure SetPageButtonImage(V_Button: TSpeedButton;V_ImageIndex: integer);
			procedure ArrangeMenuButtons;
			procedure RefreshGlyphs;
			procedure SortV_LTV_MenuItems;

			{Events}
			procedure PSetV_MenuPages(const Value: TARMenuPages);

			{Internal Object Events}
			procedure MenuButtonNotification(MenuPage: TARMenuPage);
			procedure V_OnLTV_MenuItemsClick(Sender: TObject);
			procedure V_OnLTV_MenuItemsDblClick(Sender: TObject);
			procedure V_OnListButtonClick(Sender: TObject);
			procedure V_OnReportButtonClick(Sender: TObject);
			procedure V_OnIconButtonClick(Sender: TObject);
			procedure V_OnSmallIconButtonClick(Sender: TObject);
			procedure V_OnCloseButtonClick(Sender: TObject);
			procedure PSetV_DefMenuViewStyle(const Value: TViewStyle);
			procedure PSetV_MenuViewStyleAction(const Value: TARMenuViewStyleAction);
			procedure V_LTV_MenuItemsOnColumnClick(Sender: TObject; Column: TListColumn);
			procedure V_OnToolCaptionFontChange(Sender:TObject);

			procedure Loaded;override;
			procedure PSetV_MenuAreaWidthOpened(const Value: integer);
			procedure PSetV_LTV_Sort(const Value: TARLTV_Sort);
			procedure PSetV_SortToogle(const Value: boolean);
			procedure PSetV_ToolCaptionBevelInner(const Value: TPanelBevel);
			procedure PSetV_ToolCaptionBevelOuter(const Value: TPanelBevel);
			procedure PSetV_ToolCaptionBevelWidth(const Value: integer);
			procedure PSetV_ToolCaptionBorderStyle(const Value: TBorderStyle);
			procedure PSetV_ToolCaptionBorderWidth(const Value: integer);
			procedure PSetV_ToolCaptionHeight(const Value: integer);
			procedure PSetV_ToolCaptionAlignment(const Value: TAlignment);
			procedure PSetV_ToolCaptionCaption(const Value: string);
			procedure PSetV_ToolCaptionColor(const Value: TColor);
			procedure PSetV_ToolCaptionFont(const Value: TFont);
			procedure PSetV_MenuAreaHeightOpened(const Value: integer);
			procedure PSetV_MenuAnimation(const Value: boolean);
			procedure PSetV_MenuCloseAnimationSteps(const Value: integer);
			procedure PSetV_MenuOpenAnimationSteps(const Value: integer);
			procedure PSetV_MenuPopupPosition(const Value: TARMenuPopUpPosition);
			procedure PSetV_ButtonAreaColor(const Value: TColor);
			procedure PSetV_ToolImageCenter(const Value: boolean);
			procedure PSetV_ToolImageHeight(const Value: integer);
			procedure PSetV_ToolImagePicture(const Value: TPicture);
			procedure PSetV_ToolImageStretch(const Value: boolean);
			procedure PSetV_ToolImageTransparent(const Value: boolean);
			procedure PSetV_ToolImageVisible(const Value: boolean);


		protected
			{ Protected declarations }
		public
			{ Public declarations }

			constructor Create(AOWner: TComponent);override;
			destructor Destroy; override;

		published
			{ Published declarations }

			property Author: TAboutProperty read V_About write V_About;
			property MenuPages: TARMenuPages read V_MenuPages write PSetV_MenuPages;
			property ImageList: TImageList read V_ImageList write V_ImageList;
			property MenuSmallImages: TImageList read V_MenuSmallImages write V_MenuSmallImages;
			property MenuLargeImages: TImageList read V_MenuLargeImages write V_MenuLargeImages;
			property MenuStateImages: TImageList read V_MenuStateImages write V_MenuStateImages;
			property DefMenuViewStyle: TViewStyle read V_DefMenuViewStyle write PSetV_DefMenuViewStyle;
			property ButtonAreaColor: TColor read V_ButtonAreaColor write PSetV_ButtonAreaColor;
			property MenuViewStyleAction: TARMenuViewStyleAction read V_MenuViewStyleAction write PSetV_MenuViewStyleAction;
			property MenuAreaWidthOpened: integer read V_MenuAreaWidthOpened write PSetV_MenuAreaWidthOpened;
			property MenuAreaHeightOpened: integer read V_MenuAreaHeightOpened write PSetV_MenuAreaHeightOpened;
			property MenuItemsSortType: TARLTV_Sort read V_LTV_Sort write PSetV_LTV_Sort;
			property MenuItemSortToogle: boolean read V_SortToogle write PSetV_SortToogle;
			property MenuAnimation: boolean read V_MenuAnimation write PSetV_MenuAnimation;
			property MenuAnimationOpenSteps: integer read V_MenuOpenAnimationSteps write PSetV_MenuOpenAnimationSteps;
			property MenuAnimationCloseSteps: integer read V_MenuCloseAnimationSteps write PSetV_MenuCloseAnimationSteps;
			property MenuPopUpPosition: TARMenuPopUpPosition read V_MenuPopupPosition write PSetV_MenuPopupPosition;
			property ToolCaptionHeight:integer read V_ToolCaptionHeight write PSetV_ToolCaptionHeight;
			property ToolCaptionBevelInner: TPanelBevel read V_ToolCaptionBevelInner write PSetV_ToolCaptionBevelInner;
			property ToolCaptionBevelOuter: TPanelBevel read V_ToolCaptionBevelOuter write PSetV_ToolCaptionBevelOuter;
			property ToolCaptionBevelWidth: integer read V_ToolCaptionBevelWidth write PSetV_ToolCaptionBevelWidth;
			property ToolCaptionBorderStyle: TBorderStyle read V_ToolCaptionBorderStyle write PSetV_ToolCaptionBorderStyle;
			property ToolCaptionBorderWidth: integer read V_ToolCaptionBorderWidth write PSetV_ToolCaptionBorderWidth;
			property ToolCaptionColor: TColor read V_ToolCaptionColor write PSetV_ToolCaptionColor;
			property ToolCaptionCaption: string read V_ToolCaptionCaption write PSetV_ToolCaptionCaption;
			property ToolCaptionAlignment: TAlignment read V_ToolCaptionAlignment write PSetV_ToolCaptionAlignment;
			property ToolCaptionFont: TFont read V_ToolCaptionFont write PSetV_ToolCaptionFont;
			property ToolImageStretch: boolean read V_ToolImageStretch write PSetV_ToolImageStretch;
			property ToolImageHeight: integer read V_ToolImageHeight write PSetV_ToolImageHeight;
			property ToolImageTransparent: boolean read V_ToolImageTransparent write PSetV_ToolImageTransparent;
			property ToolImagePicture: TPicture read V_ToolImagePicture write PSetV_ToolImagePicture;
			property ToolImageCenter: boolean read V_ToolImageCenter write PSetV_ToolImageCenter;
			property ToolImageVisible: boolean read V_ToolImageVisible write PSetV_ToolImageVisible;




	end;

const
	V_CloseButtonImageHeight			= 009;
	V_CloseButtonImageWidth				= 010;
	V_ClosebuttonImage					: array[1..90] of DWord = (
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00FFFFFF,
												   $00FFFFFF,$00000000,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00000000,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00000000,$00000000,$00FFFFFF,$00000000,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00000000,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00000000,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00000000,$00000000,$00FFFFFF,$00000000,$00000000,$00FFFFFF,$00FFFFFF,
												   $00FFFFFF,$00000000,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00000000,$00FFFFFF,
												   $00FFFFFF,$00000000,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00000000,$00FFFFFF,
												   $00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF,$00FFFFFF);

	V_IconImageHeight			= 015;
	V_IconImageWidth			= 016;
	V_IconImage					: array[1..240] of DWord = (
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00800000,$00800000,$00800000,$00800000,$00800000,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00800000,$00D2E0E1,$00D2E0E1,$00D2E0E1,$00800000,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00800000,$00800000,$00D2E0E1,$00D2E0E1,$00800000,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00800000,$00800000,$00800000,$00800000,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$00800000,$00800000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00D2E0E1,$00D2E0E1,$00D2E0E1,$00800000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$00D2E0E1,$00D2E0E1,$00800000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$00800000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00);

	V_ListImageHeight			= 015;
	V_ListImageWidth			= 017;
	V_ListImage					: array[1..255] of DWord = (
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00800000,$00800000,$00800000,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$0000FF00,
												   $0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,$0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,$0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00800000,$00800000,$00800000,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$0000FF00,
												   $0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,$0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,$0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00);

	V_ReportImageHeight			= 015;
	V_ReportImageWidth			= 018;
	V_ReportImage					: array[1..270] of DWord = (
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$00800000,$0000FF00,$00800000,$0000FF00,$00800000,$0000FF00,$00800000,$0000FF00,$00800000,$0000FF00,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$00000000,$0000FF00,$00800000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,$00000000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00);

	V_SmallIconImageHeight			= 015;
	V_SmallIconImageWidth			= 016;
	V_SmallIconImage					: array[1..240] of DWord = (
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00800000,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00D2E0E1,$00800000,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00800000,$00800000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$00000000,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,
												   $0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00,$0000FF00);

	V_AlbertResearchHeight			= 050;
	V_AlbertResearchWidth			= 050;
	V_AlbertResearch					: array[1..2500] of DWord = (
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00529C5A,$005A9C63,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00185218,$0052A55A,$00429C4A,$00428C42,$004A8452,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005A945A,$00529C52,$0042A54A,$00319C39,$0042A54A,$004A9452,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00216B21,$00429C42,$00399439,$00429C39,$0039A539,$0039AD39,$0042B542,$00399439,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00428C42,$0042A542,$0039A539,$0042A539,$0042AD42,$0042B539,$0029A529,$00219C21,$0042AD42,$00529C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A8C4A,$0042AD42,$0031A531,$0031AD29,$0031A529,$0031A531,$0031AD31,$0031AD29,$0029AD29,$0039AD39,$00429C42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00398C39,$0039AD39,$0029AD29,$0029AD29,$0031A529,$0031AD31,$0029A529,$0031B531,$0039BD39,$0029A529,$0042A542,$00216B21,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00639452,$00396B31,$000000FF,$000000FF,$00318C39,$0031A539,$0031AD31,$0029AD29,$0031AD31,$0039AD31,$0039AD31,$0039AD31,$0031B531,$0031AD31,$0039A539,$00429C4A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A944A,$004AA54A,$0052A542,$005AA552,$000000FF,$00317339,$00429C42,$00299C31,$0031AD31,$0031AD31,$0031AD31,$0039AD31,$0039A531,$0031AD31,$0031AD31,$0031AD31,$0039AD39,$00429C42,$00215A21,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9C52,$00399C39,$0039AD39,$0042AD42,$00399C39,$000000FF,$00398442,$00429442,$00298C29,$0039A539,$0031A539,$0031AD31,$0031AD31,$0039A531,$0031A531,$0031A531,$0031A531,$0031A531,$00399C39,$00529C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00528452,$004A9C4A,$0039A539,$0031AD39,$0029A529,$0031AD39,$0042A542,$00187318,$00429442,$00398C39,$00399431,$0039A539,$0039A539,$0039AD39,$0031AD31,$0039A539,$0039A539,$0039A539,$0039AD39,$0031AD31,$0039AD42,$004AA552,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00398439,$0042A542,$0031AD31,$0029B531,$0029AD31,$0039AD42,$0039A542,$0042A542,$00319431,$00399431,$00399431,$00399C39,$0039A539,$0031AD31,$0031AD31,$0031AD31,$0039AD39,$0039A539,$0039AD39,$0031AD31,$0029A529,$0042AD4A,$004A944A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A31,$000000FF,$000000FF,$00428C39,$0031A531,$0039B531,$0031B539,$0029AD31,$00299C31,$0039A542,$0039AD42,$00319C29,$00298C29,$00298C29,$00319431,$0031A539,$0029AD31,$0021AD29,$0031AD31,$0039AD31,$0039A539,$0039AD39,$0031B531,$0039B539,$0039A539,$004AA54A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9452,$00529C52,$006BA563,$000000FF,$000000FF,$00428C4A,$0042A542,$0031A531,$0031A531,$00299C29,$0042B54A,$0031A539,$0031AD29,$0029A529,$00299C31,$00319431,$00319431,$0031A539,$0021AD29,$0021B521,$0031B531,$0039AD31,$0039A539,$0039AD39,$0029A529,$0021A521,$0039B539,$00319431,$005A8C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$006B946B,$005A945A,$004AA54A,$00319431,$00529C4A,$000000FF,$000000FF,$00398442,$0042A54A,$0039A539,$0039A539,$0042B542,$00299429,$0031AD31,$0029A529,$0031AD31,$00219421,$00299431,$00319431,$0031A539,$0029AD29,$0021B521,$0031B531,$0039B531,$0039A539,$0039AD39,$0031B531,$0031B529,$0029A529,$004AAD39,$00528C4A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$0042944A,$0042A54A,$0039A542,$0042AD42,$0042AD42,$00429C42,$000000FF,$00186321,$00398C42,$00399442,$0042AD4A,$0039AD39,$0039AD39,$0031AD31,$0031AD31,$0039B539,$0031AD39,$00319C31,$00299431,$00319431,$0031A531,$0039AD31,$0039B531,$0031B531,$0031AD31,$0031AD39,$0031AD39,$0031B539,$0029A529,$0039AD29,$0042A531,$00529442,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00397B42,$004AA552,$0039AD42,$0031AD39,$0031AD31,$0031A531,$00319C31,$0042A54A,$000000FF,$00298431,$00318431,$00318C39,$00399C42,$0031A539,$0031AD31,$0031AD29,$0029AD29,$0031AD31,$0031A531,$00299C31,$00299431,$00299431,$00319C31,$0039A531,$0039AD31,$0031AD31,$0029AD31,$0029AD39,$0029AD39,$0021A529,$0039BD39,$0039AD29,$0039A529,$005AA542,$005A8C52,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005AA552,$004AA542,$0039A539,$0039AD31,$0031B531,$0029A529,$0039B539,$0039AD39,$004AAD4A,$000000FF,$00399C42,$00319439,$00399C42,$0042AD4A,$0031A531,$0031AD31,$0031AD31,$0031AD29,$0031AD31,$0031A531,$00299C31,$00299431,$00299431,$00319431,$0039A531,$0039AD31,$0031AD29,$0029AD31,$0029A531,$0029AD39,$0029AD31,$0031AD31,$0039B529,$0042B529,$00429C31,$004A9442,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00397B42,$00529C4A,$00399C31,$0039A531,$0031A529,$0039B531,$00219C21,$0031AD31,$0031A529,$0039AD39,$00299C29,$0052BD52,$00298C29,$00298C31,$00319431,$0031A539,$0031AD31,$0031AD31,$0031B529,$0031B529,$0031B531,$0031AD31,$0031A531,$00319C31,$00298C31,$00319431,$0031A531,$0039AD31,$0039AD31,$0031AD31,$0029A531,$0029AD39,$0031B539,$0029AD29,$0029AD21,$0039B529,$0042AD31,$004AA542,$004A8C52,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9C52,$004AAD4A,$0039A531,$0042B539,$0029A529,$0039B531,$0029A521,$0031AD31,$0039B539,$0031AD31,$0042B539,$00299C29,$0031A531,$00299431,$00319C31,$00319C31,$00299C29,$0031AD31,$0031AD29,$0029AD29,$0029AD29,$0031AD31,$0031AD31,$0031A531,$00299C31,$00298C31,$00319439,$00399C31,$0039AD31,$0039AD31,$0039AD31,$0031AD39,$0031AD39,$0029AD31,$0031B531,$0029AD29,$0031AD29,$0039AD31,$0039A539,$004AA552,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00216B29,$00429C42,$0039A539,$0031AD31,$0031AD31,$0031AD31,$0039B539,$0029A529,$0031A531,$0039AD39,$0039AD31,$0039AD31,$0031AD31,$0039A531,$0039AD39,$00299429,$00299429,$0031A531,$00299C29,$0039AD39,$0031AD31,$0031AD29,$0031AD31,$0031AD31,$0039AD39,$0039A539,$00319C31,$00318C39,$00319439,$00319C31,$0039A531,$0042AD31,$0039AD31,$0039AD39,$0031AD39,$0039AD42,$0029A531,$0031AD29,$0039BD39,$0031AD29,$0031A531,$00399C42,$00216B29,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$00529C4A,$0052AD4A,$0031A529,$0039B539,$0029AD31,$0031B539,$0031AD39,$0039AD42,$0039AD42,$00299C31,$0042AD42,$00399C31,$0042AD42,$0031A531,$0039AD39,$0042B542,$00299429,$00219421,$00319C31,$00319C31,$0039AD39,$0039AD31,$0039AD31,$0039AD39,$0039AD39,$0042AD42,$0042AD42,$00399C39,$00319439,$00319439,$00319C31,$00399C29,$0039A531,$0039A531,$0039A539,$0039A542,$0039A542,$00299C31,$0029A529,$0031AD31,$0031AD31,$0039AD42,$0039A542,$0052A55A,$000000FF,$000000FF,
												   $000000FF,$000000FF,$00638C5A,$00528C4A,$0052A542,$00399C29,$004ABD42,$0031A531,$0031AD39,$0031AD39,$00299C39,$00299C39,$0039A542,$0042A54A,$0042A542,$0042A542,$00399C39,$0039A539,$0042A542,$0042AD42,$00319C31,$00299429,$00299429,$00319C31,$0039A539,$0039A539,$0039A539,$0039A539,$0039A539,$0042A542,$0042A542,$00399C39,$00319439,$00319439,$00319431,$00319C29,$00399C31,$0042A531,$0042A542,$0042A542,$0042A54A,$0039A542,$0042B54A,$00299C31,$0039A539,$0039A539,$0039A539,$004A944A,$000000FF,$000000FF,
												   $000000FF,$0052844A,$00528C4A,$0063A55A,$00429442,$0052A552,$00399439,$0042A54A,$0039A542,$0039A542,$00399C42,$00429C42,$00429C4A,$00429C42,$004AA54A,$004AA54A,$00429C42,$004AA54A,$0042A542,$004AAD4A,$0042A542,$00399C39,$00319431,$00319439,$0042A542,$00429C42,$00429C42,$0042A54A,$00429C4A,$004AA54A,$004AA54A,$0042A54A,$00298C31,$00298C31,$00399C39,$00319429,$004AA539,$00429C39,$004AA54A,$00429442,$00429C4A,$00399442,$004AA54A,$00429C42,$0042A542,$0042A542,$00399C42,$00529C52,$00528452,$000000FF,
												   $00316B21,$00397331,$00317331,$00215A21,$00297331,$00216B29,$00217329,$00186B21,$00217329,$00187321,$00217321,$00217B21,$00297B29,$00217318,$00106310,$00217321,$00217329,$00297329,$00187321,$00187318,$00217321,$00298429,$00318C31,$00399439,$00217321,$00187321,$00217321,$00217329,$00217321,$00217321,$00217321,$00217321,$00399C42,$00319C39,$00319431,$00318C29,$00217B18,$00217318,$00217321,$00297329,$00216B29,$00297B31,$00217329,$00186B21,$00217321,$00186318,$00317B31,$00216321,$00426B42,$000000FF,
												   $000000FF,$00295A29,$00316331,$00296331,$00396B42,$00296331,$00296331,$00317339,$00216321,$00296B21,$00317B29,$00216B18,$00216B21,$00297329,$00216B21,$00296B29,$00296B29,$00297331,$00216B29,$00216B21,$00297B29,$00398C39,$00429442,$00398C39,$00216B21,$00216B21,$00296B29,$00296B31,$00296B29,$00216B29,$00216B21,$00217321,$00319439,$00299431,$00298C29,$00399439,$00217318,$00216B21,$00216321,$00296B29,$00296329,$00317331,$00216321,$00296B29,$00296B31,$00296B29,$00296329,$00316331,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$00315A39,$00395A42,$00426B4A,$00315A31,$00396B39,$00396B39,$00397331,$00397329,$00296B21,$00216321,$00317329,$00397B31,$00296B29,$00296329,$00316B31,$00296B31,$00216B21,$00318431,$00398C39,$00398C39,$00318431,$00296B29,$00296B31,$00296B31,$00316B39,$00316B31,$00296B29,$00296B29,$00297B29,$00399439,$00319431,$00318C31,$00429442,$00297329,$00317331,$00316B31,$00296329,$00316B31,$00316B31,$00316B31,$00316B31,$00295A29,$00316331,$00396339,$004A6B4A,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$00395A42,$00395A39,$00426339,$00315A29,$00396331,$00316329,$00296321,$00397339,$00396B31,$00215A21,$00316B31,$00316B31,$00316339,$00316331,$00316B31,$00296B29,$00428C39,$00428C39,$00429442,$00428C42,$00216B29,$00296B29,$00296331,$00296331,$00296331,$00216329,$00296B29,$00317B31,$00429C39,$00399431,$00429439,$00297329,$00296329,$00296329,$00396B39,$00296329,$00396B31,$00316331,$00316331,$00316331,$00396331,$00315A31,$00395A39,$00315239,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A39,$00395A31,$00426339,$00426B39,$00315A29,$00295A29,$00396B39,$00316B31,$00316331,$00316331,$00316339,$00295A29,$00316B31,$00296B21,$00428C42,$00398C39,$00428C39,$00398439,$00296B31,$00316B39,$00316B39,$00316339,$00316B31,$00296B29,$00317331,$00428C39,$00399431,$00399431,$00429442,$00296B29,$00316331,$00295A31,$00426B42,$00316331,$00316331,$00316B31,$00316329,$00396331,$00315A31,$004A6B4A,$00426342,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A39,$00295231,$00426B4A,$00396B42,$00316339,$00396B39,$00316339,$00427342,$00396339,$00316331,$00397339,$00296B29,$004A9442,$00398C39,$00398C39,$00297321,$00296B29,$00316B31,$00296331,$00316331,$00316331,$00296329,$00317329,$00428C39,$00399431,$00429439,$00428C42,$00317339,$00316B39,$00316339,$00316339,$00396339,$00295A29,$00316329,$00316329,$00427339,$00315A31,$00395A39,$00395A42,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00315239,$00396342,$00315A39,$00426B42,$00295A29,$00396339,$00396339,$00316331,$00396B31,$00215A18,$00428C42,$00428C39,$00428C39,$00216B21,$00296B29,$00316B31,$00316331,$00316331,$00316B31,$00296B29,$00317B29,$00429442,$00398C31,$00428C39,$00216B21,$00296329,$00295A31,$00396342,$00315A31,$00396B39,$00396B31,$00316B31,$00316B31,$00295A29,$00426342,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00395A42,$00395A42,$00396342,$00316339,$00316331,$00316331,$00397339,$000000FF,$00397B42,$00428442,$004A8C42,$00296B21,$00317329,$00316B31,$00316B31,$00296331,$00296B31,$00297329,$00398C39,$00429439,$00398C39,$00429442,$00296B29,$00296329,$00316B39,$00316331,$00316331,$00316B31,$00316B31,$00296329,$00396B39,$00315A31,$00395A39,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$0042634A,$00395A42,$00426342,$00395A39,$00396331,$00396B31,$00316331,$000000FF,$004A8452,$00528C4A,$00428442,$00316B29,$00316B29,$00397B39,$00296329,$00316B31,$00296B31,$00297329,$00318431,$00429442,$00398C39,$00398439,$00296B29,$00296B29,$00316B31,$00316331,$00316B31,$00316B31,$00296329,$00296331,$00296331,$00396B39,$00426342,$00425239,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A42,$00426342,$00396339,$00426B39,$00315A31,$000000FF,$000000FF,$00427342,$00316B31,$00316B29,$00397331,$00296B29,$00296329,$00317339,$00317B31,$00216B21,$00429439,$00398C39,$00428C42,$00297329,$00296B29,$00316B31,$00296329,$00316B31,$00396B39,$00316B31,$00316B39,$00316B31,$00396B39,$00396339,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00395A39,$00426342,$00395A39,$000000FF,$000000FF,$00528452,$00316329,$00316B31,$00316329,$00316B29,$00296329,$00296B31,$00216B29,$00398C42,$00429442,$00298429,$00428C42,$00216B21,$00316B31,$00316B31,$00296329,$00396B39,$00316B31,$00316B31,$00316331,$00316B31,$00316339,$00396339,$00395A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395239,$004A634A,$000000FF,$000000FF,$004A7B52,$00396339,$00316B31,$00396B31,$00316B31,$00316B39,$00185A21,$00317331,$00398C42,$00398C31,$00429C42,$00398439,$00296B29,$00296B29,$00296B29,$00316B31,$00316B31,$00296329,$00316B31,$00397339,$00316331,$00315A31,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005A7B5A,$00426339,$00396331,$00396B31,$00296329,$00397339,$00316B31,$00297331,$00398C42,$00398C39,$00398C39,$00317331,$00296B29,$00296B29,$00296329,$00316B31,$00316331,$00295A29,$00316331,$00316331,$00396339,$00315A39,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00426339,$00426339,$00396331,$00427342,$00215A29,$00296331,$00216329,$004A9452,$00429C42,$00318431,$00296B29,$00317331,$00296329,$00316329,$00316B31,$00296329,$00316331,$00316331,$00396B39,$00315A31,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00426339,$004A6B42,$00396339,$00396339,$00397342,$000000FF,$00398442,$00398C39,$00428C42,$00296B29,$00397331,$00316329,$00316B31,$00316B31,$00296329,$00396B39,$00316331,$00316339,$00396339,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A39,$00395A31,$00426342,$00396339,$000000FF,$00428442,$004A944A,$00398431,$00397331,$00316329,$00316B31,$00316329,$00316B31,$00316331,$00396B39,$00396B39,$00396342,$00426342,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A6B4A,$00425A42,$00395A39,$000000FF,$00316331,$00397B39,$00317331,$00296329,$00396B39,$00396B39,$00295A29,$00296329,$00316B31,$00396B39,$00315A31,$00426342,$00395A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00394A39,$000000FF,$000000FF,$000000FF,$005A8C52,$00316329,$00316331,$00396339,$00316331,$00396B39,$00316331,$00316331,$00316339,$00396B42,$00396339,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426B42,$00396331,$00426339,$00396339,$00295A29,$00396B39,$00396B39,$00396B39,$00316331,$00396339,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A42,$00426342,$00426342,$00395A39,$00396339,$00396B39,$00296329,$00316B39,$00396B39,$00396339,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00395A39,$00427342,$00315A31,$00316B39,$00316331,$00295A29,$00426B42,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00315231,$00395A39,$00316331,$00316331,$00295A29,$00396B39,$00315A31,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A39,$00315A39,$00396B42,$00315A39,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00425A42,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00526352,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF);

procedure Register;

implementation

procedure Register;
begin
	RegisterComponents('AR_Albert Research[0]', [TARMenuToolBar]);
	RegisterPropertyEditor(TypeInfo(TAboutProperty), TARMenuToolBar, 'Author', TAboutProperty);
end;

{ TARMenuToolBar }


constructor TARMenuToolBar.Create(AOWner: TComponent);
begin
	inherited Create(AOwner);

	{Size Settings}
	V_ARMenuToolBarWidth := 200;
	Width := V_ARMenuToolBarWidth;
	V_MenuAreaWidthOpened := 230;
	V_MenuAreaHeightOpened := 200;
	Height := 200;


	{Menu Area}
	V_MenuArea := TPanel.Create(Self);
	if csDesigning in ComponentState then
		begin
			V_MenuArea.Parent := TWinControl(AOwner);		
		end
	else
		begin
			V_MenuArea.Parent := TForm(AOwner);		
		end;

	V_MenuArea.Align := alNone;
	V_MenuArea.Height := 0;
	V_MenuArea.Width := 0;
	V_MenuArea.Visible := False;

	V_MenuAnimation := True;
	V_MenuOpenAnimationSteps := 50;
	V_MenuCloseAnimationSteps := 40;
	V_MenuPopUpPosition := pop_Right;

	{Button Area}
	V_ButtonArea := TPanel.Create(Self);
	V_ButtonArea.Parent := Self;
	V_ButtonArea.Align := alClient;
	V_ButtonAreaColor := V_ButtonArea.Color;



	{ToolCaption}
	V_ToolCaption := TPanel.Create(V_ButtonArea);
	V_ToolCaption.Parent := V_ButtonArea;
	V_ToolCaption.BevelInner := bvSpace;
	V_ToolCaption.BevelOuter := bvLowered;
	V_ToolCaption.BevelWidth := 1;
	V_ToolCaption.BorderStyle := bsSingle;
	V_ToolCaption.Align := alTop;
	V_ToolCaption.Height := 30;
	V_ToolCaption.Alignment := taLeftJustify;
	V_ToolCaption.Color := clActiveCaption;
	V_ToolCaption.Caption := 'ARMenuToolBar V1.0  AR 98';

	V_ToolCaptionBevelInner := V_ToolCaption.BevelInner;
	V_ToolCaptionBevelOuter := V_ToolCaption.BevelOuter;
	V_ToolCaptionBevelWidth := V_ToolCaption.BevelWidth;
	V_ToolCaptionBorderStyle := V_ToolCaption.BorderStyle;;
	V_ToolCaptionBorderWidth := V_ToolCaption.BorderWidth;
	V_ToolCaptionHeight := V_ToolCaption.Height;
	V_ToolCaptionColor := V_ToolCaption.Color;
	V_ToolCaptionCaption := V_ToolCaption.Caption;

	V_ToolCaptionFont := TFont.Create;
	V_ToolCaptionFont.OnChange := V_OnToolCaptionFontChange;
	V_ToolCaptionFont.Name := 'Arial';
	V_ToolCaptionFont.Size := 10;
	V_ToolCaptionFont.Color := clHighLightText;
	V_ToolCAptionFont.Style := [fsItalic];

	{ToolImage}
	V_ToolImagePanel := TPanel.Create(V_ButtonArea);
	V_ToolImagePanel.Parent := V_ButtonArea;
	V_ToolImagePanel.BevelInner := bvnone;
	V_ToolImagePanel.BevelOuter := bvNone;
	V_ToolImagePanel.BorderStyle := bsNone;
	V_ToolImagePanel.BorderWidth := 0;
	V_ToolImagePanel.Align := alBottom;
	V_ToolImagePanel.ParentColor := True;
	V_ToolImagePanel.Height := 30;

	V_ToolImage := TImage.Create(V_ToolImagePanel);
	V_ToolImagePicture := TPicture.Create;

	V_ToolImage.Parent := V_ToolImagePanel;
	V_ToolImage.Align := alClient;
	V_ToolImage.Stretch := False;
	V_ToolImage.Transparent := True;
	V_ToolImage.Center := False;
	V_ToolImage.Visible := True;


	V_ToolImageStretch := V_ToolImage.Stretch;
	V_ToolImageHeight := V_ToolImagePanel.Height;
	V_ToolImageTransparent := V_ToolImage.Transparent;
	V_ToolImageCenter := V_ToolImage.Center;
	V_ToolImageVisible := V_ToolImage.Visible;


	{Caption Panel}
	V_CaptionPanel := TPanel.Create(V_MenuArea);
	V_CaptionPanel.Parent := V_MenuArea;
	V_CaptionPanel.Align := alTop;
	V_CaptionPanel.Height := 60;

	{Caption for the MenuBar}
	V_MenuCaption := TImage.Create(V_CaptionPanel);
	V_MenuCaption.Parent := V_CaptionPanel;
	V_MenuCaption.Top := 4;
	V_MenuCaption.Left := 4;
	V_MenuCaption.Height := 20;
	V_MenuCaption.Width := V_MenuAreaWidthOpened - 33 ;

	{Close Menu Button}
	V_CloseButton := TSpeedButton.Create(V_CaptionPanel);
	V_CloseButton.Parent := V_CaptionPanel;
	V_CloseButton.Top := 4;
	V_CloseButton.Width := 20;
	V_CloseButton.Height := 22;
	V_CloseButton.Left := V_MenuAreaWidthOpened - 26;
	V_CloseButton.Caption := '';
	V_CloseButton.Flat := True;
	V_CloseButton.OnClick := V_OnCloseButtonClick;
	V_CloseButton.ShowHint := True;
	{$IFDEF ENGLISH}
		V_CloseButton.Hint := 'Close Menu';
	{$ELSE}
		V_CloseButton.Hint := 'Cerrar Menu';
	{$ENDIF}


	{Menu Items ListView}
	V_LTV_MenuItems := TListView.Create(V_MenuArea);
	V_LTV_MenuItems.Parent := V_MenuArea;
	V_LTV_MenuItems.Align := alClient;
	V_LTV_MenuItems.ColumnClick := True;
	V_LTV_MenuItems.FlatScrollBars := True;
	V_LTV_MenuItems.HideSelection := False;
	V_LTV_MenuItems.ReadOnly := True;
	V_LTV_MenuItems.RowSelect := True;
	V_LTV_MenuItems.ViewStyle := vsReport;
	V_LTV_MenuItems.Items.Clear;
	V_LTV_MenuItems.OnClick := V_OnLTV_MenuItemsClick;
	V_LTV_MenuItems.OnDblClick := V_OnLTV_MenuItemsDblClick;
	V_LTV_MenuItems.Color := clWindow;

	V_LTV_MenuItemsColumn := V_LTV_MenuItems.Columns.Add;
	V_LTV_MenuItemsColumn.AutoSize := True;
	V_LTV_MenuItemsColumn.ImageIndex := 0;

	V_DefMenuViewStyle := vsReport;
	V_DefaultApplied := False;
	V_MenuViewStyleAction := arvs_RememberLast;


	V_LTV_Sort := sort_NoSort;
	V_SortToogle := False;
	V_LTV_MenuItems.OnColumnClick := V_LTV_MenuItemsOnColumnClick;


	{ListView Interaction Objects}

	{ListButton}
	V_ListButton := TSpeedButton.Create(V_CaptionPanel);
	V_ListButton.Parent := V_CaptionPanel;
	V_ListButton.Top := 36;
	V_ListButton.Width := 20;
	V_ListButton.Height := 20;
	V_ListButton.Left := 4;
	V_ListButton.Caption := '';
	V_ListButton.Flat := True;
	V_ListButton.GroupIndex := 1;
	V_ListButton.AllowAllUp := False;
	V_ListButton.OnClick := V_OnListButtonClick;
	V_ListButton.ShowHint := True;
	{$IFDEF ENGLISH}
		V_ListButton.Hint := 'List View Style';
	{$ELSE}
		V_ListButton.Hint := 'Ver en Modo Lista';
	{$ENDIF}


	{ReportButton}
	V_ReportButton := TSpeedButton.Create(V_CaptionPanel);
	V_ReportButton.Parent := V_CaptionPanel;
	V_ReportButton.Top := 36;
	V_ReportButton.Width := 20;
	V_ReportButton.Height := 20;
	V_ReportButton.Left := 28;
	V_ReportButton.Caption := '';
	V_ReportButton.Flat := True;
	V_ReportButton.GroupIndex := 1;
	V_ReportButton.AllowAllUp := False;
	V_ReportButton.Down := True;
	V_ReportButton.OnClick := V_OnReportButtonClick;
	V_ReportButton.ShowHint := True;
	{$IFDEF ENGLISH}
		V_ReportButton.Hint := 'Report View Style';
	{$ELSE}
		V_ReportButton.Hint := 'Ver en Modo Reporte';
	{$ENDIF}


	{IconButton}
	V_IconButton := TSpeedButton.Create(V_CaptionPanel);
	V_IconButton.Parent := V_CaptionPanel;
	V_IconButton.Top := 36;
	V_IconButton.Width := 20;
	V_IconButton.Height := 20;
	V_IconButton.Left := 52;
	V_IconButton.Caption := '';
	V_IconButton.Flat := True;
	V_IconButton.GroupIndex := 1;
	V_IconButton.AllowAllUp := False;
	V_IconButton.OnClick := V_OnIconButtonClick;
	V_IconButton.ShowHint := True;
	{$IFDEF ENGLISH}
		V_IconButton.Hint := 'Icon View Style';
	{$ELSE}
		V_IconButton.Hint := 'Ver en Modo Iconos';
	{$ENDIF}



	{SmallIconButton}
	V_SmallIconButton := TSpeedButton.Create(V_CaptionPanel);
	V_SmallIconButton.Parent := V_CaptionPanel;
	V_SmallIconButton.Top := 36;
	V_SmallIconButton.Width := 20;
	V_SmallIconButton.Height := 20;
	V_SmallIconButton.Left := 76;
	V_SmallIconButton.Caption := '';
	V_SmallIconButton.Flat := True;
	V_SmallIconButton.GroupIndex := 1;
	V_SmallIconButton.AllowAllUp := False;
	V_SmallIconButton.OnClick := V_OnSmallIconButtonClick;
	V_SmallIconButton.ShowHint := True;
	{$IFDEF ENGLISH}
		V_SmallIconButton.Hint := 'SmallIcon View Style';
	{$ELSE}
		V_SmallIconButton.Hint := 'Ver en Modo Iconos Pequeos';
	{$ENDIF}


	{MenuPages}
	V_MenuPages := TARMenuPages.Create(Self);


	{Variables}
	V_MenuStatus := men_Closed;

	{Initialize the variable that stores de active Menu Index Page to -1 so we now that there is no page selected}
	V_ActiveMenuIndex := -1;

end;

destructor TARMenuToolBar.Destroy;
begin
	{Free MenuPages}
	V_MenuPages.Free;

	if V_OwnerIsForm then
		begin
			{ListView Interaction Buttons}
			V_ListButton.OnClick := nil;
			V_ListButton.Free;
			V_ReportButton.OnClick := nil;
			V_ReportButton.Free;
			V_IconButton.OnClick := nil;
			V_IconButton.Free;
			V_SmallIconButton.OnClick := nil;
			V_SmallIconButton.Free;

			{Free Menu Items ListView}
			V_LTV_MenuItems.OnClick := nil;
			V_LTV_MenuItems.OnDblClick := nil;
			V_LTV_MenuItems.OnColumnClick := nil;
			V_LTV_MenuItemsColumn.Free;
			V_LTV_MenuItems.Items.Clear;
			V_LTV_MenuItems.Free;

			{Free Closebutton}
			V_CloseButton.OnClick := nil;
			V_CloseButton.Free;
			{Free MenuCaption}
			V_MenuCaption.Free;

			{Free Caption Bevel}
			V_CaptionPanel.Free;

			{ToolImage}
			V_ToolImagePicture.Free;
			V_ToolImage.Free;
			V_ToolImagePanel.Free;

			{ToolCaption}
			V_ToolCaptionFont.OnChange := nil;
			V_ToolCaptionFont.Free;
			V_ToolCaption.Free;


			{Button Area}
			V_ButtonArea.Free;

			{Menu Area}
			V_MenuArea.Free;
		end;

	inherited Destroy;
end;

procedure TARMenuToolBar.PSetV_MenuPages(const Value: TARMenuPages);
begin
	V_MenuPages.Assign(Value);
end;

procedure TARMenuToolBar.MenuButtonNotification(MenuPage: TARMenuPage);

	procedure SetViewStyle;
	var
		V_FontHeight		: integer;
		V_X,V_Y				: integer;
	begin
		{Depending on what kind of MenuView...}
		case V_MenuViewStyleAction of
			arvs_RememberLast:
				begin
					{if Default View Style not applied then Apply an mark that is was applied}
					if not V_DefaultApplied then
						begin
							V_LTV_MenuItems.ViewStyle := V_DefMenuViewStyle;
							V_DefaultApplied := True;
						end;
				end;
			arvs_AlwaysDefault:
				begin
					V_LTV_MenuItems.ViewStyle := V_DefMenuViewStyle;
				end;
		end;

		{Push down the button of the applied ViewStyle}
		case V_LTV_MenuItems.ViewStyle of
			vsList:
				begin
					V_ListButton.Down := True;
				end;
			vsReport:
				begin
					V_ReportButton.Down := True;
				end;
			vsIcon:
				begin
					V_IconButton.Down := True;
				end;
			vsSmallIcon:
				begin
					V_SmallIconButton.Down := True;
				end;
		end;

		{Set the Font}
		V_LTV_MenuItems.Font.Assign(MenuPage.MenuFont);

		{Set the Color}
		V_LTV_MenuItems.Color := MenuPage.MenuColor;

		{Fill the Gradient}
		GradientFill(V_MenuCaption,MenuPage.MenuCaptionBeginColor,MenuPage.MenuCaptionEndColor,MenuPage.MenuGradientWidth);

		V_MenuCaption.Canvas.Font.Assign(MenuPage.MenuFont);
		V_MenuCaption.Canvas.Brush.Style := bsClear;

	   V_FontHeight := V_MenuCaption.Canvas.TextHeight('W');
	   V_X := 4;
	   V_Y := (V_MenuCaption.Height - V_FontHeight) shr 1;

	   V_MenuCaption.Canvas.TextOut(V_X,V_Y,MenuPage.MenuCaption);

	end;

	procedure FillItems;
	var
		ItemNumber			: integer;
		V_Item				: TListItem;
	begin
		V_LTV_MenuItems.Items.Clear;
		SetViewStyle;
		V_LTV_MenuItems.SmallImages := V_MenuSmallImages;
		V_LTV_MenuItems.LargeImages := V_MenuLargeImages;
		V_LTV_MenuItems.StateImages := V_MenuStateImages;
		V_LTV_MenuItemsColumn.Caption := MenuPage.MenuCaption;
		for ItemNumber := 0 to MenuPage.MenuItems.Count - 1 do
			begin
				V_Item := V_LTV_MenuItems.Items.Add;
				V_Item.Caption := MenuPage.MenuItems.Items[ItemNumber].ItemCaption; {MenuItem Caption}
				V_Item.SubItems.Add(IntToStr(MenuPage.Index)); {Index at the MenuPages}
				V_Item.SubItems.Add(IntToStr(ItemNumber)); {Index at MenuItems}

				V_Item.ImageIndex := MenuPage.MenuItems.Items[ItemNumber].ImageIndex;
				V_Item.StateIndex := MenuPage.MenuItems.Items[ItemNumber].StateIndex;
			end;

		SortV_LTV_MenuItems;
	end;

begin
	{If the ActiveMenuIndex has not been initialized or it is diferent than the active then open the menu area}
	if (V_ActiveMenuIndex = - 1) OR (MenuPage.Index <> V_ActiveMenuIndex) then
		begin
			case V_MenuStatus of
				men_Closed:
					begin
						{Open Menu Bar and Fill}
						FillItems;
						OpenMenu;

					end;
				men_Opened:
					begin
						{Refresh Data with new selection}
						FillItems;
					end;
			end;
		end
	else
		begin
			case V_MenuStatus of
				men_Closed:
					begin
						OpenMenu;
						SetViewStyle;
					end;
				men_Opened:
					begin
						CloseMenu;
						SetViewStyle;
					end;
			end;
		end;
	V_ActiveMenuIndex := MenuPage.Index;
end;

procedure TARMenuToolBar.V_OnLTV_MenuItemsClick(Sender: TObject);
var
	V_Item					: TListItem;
	V_MenuPageIndex			: integer;
	V_MenuItemIndex			: integer;
begin
	V_Item := V_LTV_MenuItems.Selected;

	if V_Item = nil then
		exit;

	V_MenuPageIndex := StrToIntDef(V_Item.SubItems[0],-1);
	V_MenuItemIndex := StrToIntDef(V_Item.SubItems[1],-1);

	if (V_MenuPageIndex = -1) OR (V_MenuItemIndex = -1) then
		exit;

	{If not enabled then exit}
	if not V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].ItemEnabled then
		exit;

	if Assigned(V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].V_OnMenuItemClick) then
		begin
			V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].V_OnMenuItemClick(Self);
			if V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].CloseMenuOnAction then
				begin
					CloseMenu;
				end;
		end;
end;

procedure TARMenuToolBar.V_OnLTV_MenuItemsDblClick(Sender: TObject);
var
	V_Item					: TListItem;
	V_MenuPageIndex			: integer;
	V_MenuItemIndex			: integer;
begin
	V_Item := V_LTV_MenuItems.Selected;

	if V_Item = nil then
		exit;

	V_MenuPageIndex := StrToIntDef(V_Item.SubItems[0],-1);
	V_MenuItemIndex := StrToIntDef(V_Item.SubItems[1],-1);

	if (V_MenuPageIndex = -1) OR (V_MenuItemIndex = -1) then
		exit;

	{If not enabled then exit}
	if not V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].ItemEnabled then
		exit;

	if Assigned(V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].V_OnMenuItemDblClick) then
		begin
			V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].V_OnMenuItemDblClick(Self);
			if V_MenuPages.Items[V_MenuPageIndex].V_ARMenuItems[V_MenuItemIndex].CloseMenuOnAction then
				begin
					CloseMenu;
				end;
		end;


end;
procedure TARMenuToolBar.CloseMenu;
var
	V_Top					: double;
	V_Height				: double;
	V_Width					: double;
	V_Left					: double;
	V_Step					: double;
begin
	case V_MenuPopUpPosition of
		pop_Left,pop_Right:
			begin
				if V_MenuAnimation then
					begin
						V_Height := V_MenuArea.Height;
						V_Top := V_MenuArea.Top;
						V_Step := V_Height / V_MenuCloseAnimationSteps;
						repeat
							V_MenuArea.Top := Round(V_Top);
							Application.ProcessMessages;

							V_MenuArea.Height := Round(V_Height);
							Application.ProcessMessages;

							V_Top := V_Top + V_Step;
							V_Height := V_Height - 2*V_Step;
						until V_Height <= 0;

						V_MenuArea.Visible := False;
						Application.ProcessMessages;
					end
				else
					begin
						V_MenuArea.Visible := False;
						Application.ProcessMessages;
					end;
			end;
		pop_Top,pop_Bottom:
			begin
				if V_MenuAnimation then
					begin
						V_Width := V_MenuArea.Width;
						V_Left := V_MenuArea.Left;
						V_Step := V_Width / V_MenuCloseAnimationSteps;
						repeat
							V_MenuArea.Left := Round(V_Left);
							Application.ProcessMessages;

							V_MenuArea.Width := Round(V_Width);
							Application.ProcessMessages;

							V_Left := V_Left + V_Step;
							V_Width := V_Width - 2*V_Step;
						until V_Width <= 0;

						V_MenuArea.Visible := False;
						Application.ProcessMessages;
					end
				else
					begin
						V_MenuArea.Visible := False;
						Application.ProcessMessages;
					end;
			end;
	end;

	V_MenuStatus := men_Closed;
end;

procedure TARMenuToolBar.OpenMenu;
var
	V_Left					: double;
	V_Width					: double;
	V_Height				: double;
	V_Top					: double;
	V_Step					: double;

	{Absolute Positions}
	V_AbsLeft				: integer;
	V_AbsTop				: integer;

begin
	if V_OwnerIsForm then
		begin
			V_AbsLeft := Left;
			V_AbsTop := Top;
		end
	else
		begin
			V_AbsLeft := V_Owner.Left + Left;
			V_AbsTop := V_Owner.Top + Top;
		end;

	case V_MenuPopUpPosition of
		pop_Right:
			begin
				if V_MenuAnimation then
					begin
						V_MenuArea.Top := V_AbsTop;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_Step := V_MenuAreaWidthOpened/V_MenuOpenAnimationSteps;
						V_MenuArea.Left := (Width + V_AbsLeft) + (V_MenuAreaWidthOpened div 2);
						V_Left := V_MenuArea.Left;
						V_Width := 0;
						repeat
							V_MenuArea.Left := Round(V_Left);
							Application.ProcessMessages;
							V_MenuArea.Width := Round(V_Width);
							Application.ProcessMessages;
							V_MenuArea.Visible := True;

							V_Left := V_Left - V_Step;
							V_Width := V_Width + 2*V_Step;
						until V_Width >= V_MenuAreaWidthOpened;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_MenuArea.Left := Width + V_AbsLeft;
					end
				else
					begin
						V_MenuArea.Top := V_AbsTop;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_MenuArea.Left := Width + V_AbsLeft;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_MenuArea.Visible := True;
						Application.ProcessMessages;
					end;
			end;
		pop_Left:
			begin
				if V_MenuAnimation then
					begin
						V_MenuArea.Top := V_AbsTop;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_Step := V_MenuAreaWidthOpened/V_MenuOpenAnimationSteps;
						V_MenuArea.Left := V_AbsLeft - (V_MenuAreaWidthOpened div 2);
						V_Left := V_MenuArea.Left;
						V_Width := 0;
						repeat
							V_MenuArea.Left := Round(V_Left);
							Application.ProcessMessages;
							V_MenuArea.Width := Round(V_Width);
							Application.ProcessMessages;
							V_MenuArea.Visible := True;
							V_Left := V_Left - V_Step;
							V_Width := V_Width + 2*V_Step;
						until V_Width >= V_MenuAreaWidthOpened;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_MenuArea.Left := V_AbsLeft - V_MenuAreaWidthOpened;
					end
				else
					begin
						V_MenuArea.Top := V_AbsTop;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_MenuArea.Left := V_AbsLeft - V_MenuAreaWidthOpened;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_MenuArea.Visible := True;
						Application.ProcessMessages;
					end;

			end;
		pop_Top:
			begin
				if V_MenuAnimation then
					begin
						V_MenuArea.Top := V_AbsTop  - (V_MenuAreaHeightOpened div 2);
						V_Step := V_MenuAreaHeightOpened/V_MenuOpenAnimationSteps;
						V_MenuArea.Left := V_AbsLeft;
						V_Top := V_MenuArea.Top;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_Height := 0;
						repeat
							V_MenuArea.Top:= Round(V_Top);
							Application.ProcessMessages;
							V_MenuArea.Height := Round(V_Height);
							Application.ProcessMessages;
							V_MenuArea.Visible := True;

							V_Top := V_Top - V_Step;
							V_Height := V_Height + 2*V_Step;

						until V_Height >= V_MenuAreaHeightOpened;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_MenuArea.Top := V_AbsTop - V_MenuAreaHeightOpened;
					end
				else
					begin
						V_MenuArea.Top := V_AbsTop - V_MenuAreaHeightOpened;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_MenuArea.Left := V_AbsLeft;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_MenuArea.Visible := True;
						Application.ProcessMessages;
					end;

			end;
		pop_Bottom:
			begin
				if V_MenuAnimation then
					begin
						V_MenuArea.Top := (V_AbsTop + Height) + (V_MenuAreaHeightOpened div 2);
						V_Step := V_MenuAreaHeightOpened/V_MenuOpenAnimationSteps;
						V_MenuArea.Left := V_AbsLeft;
						V_Top := V_MenuArea.Top;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_Height := 0;
						repeat
							V_MenuArea.Top:= Round(V_Top);
							Application.ProcessMessages;
							V_MenuArea.Height := Round(V_Height);
							Application.ProcessMessages;
							V_MenuArea.Visible := True;

							V_Top := V_Top - V_Step;
							V_Height := V_Height + 2*V_Step;

						until V_Height >= V_MenuAreaHeightOpened;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_MenuArea.Top := V_AbsTop + Height;
					end
				else
					begin
						V_MenuArea.Top := V_AbsTop + Height;
						V_MenuArea.Height := V_MenuAreaHeightOpened;
						V_MenuArea.Left := V_AbsLeft;
						V_MenuArea.Width := V_MenuAreaWidthOpened;
						V_MenuArea.Visible := True;
						Application.ProcessMessages;
					end;

			end;
	end;


	V_MenuStatus := men_Opened;
end;


procedure TARMenuToolBar.V_OnIconButtonClick(Sender: TObject);
begin
	V_LTV_MenuItems.ViewStyle := vsIcon;
end;

procedure TARMenuToolBar.V_OnListButtonClick(Sender: TObject);
begin
	V_LTV_MenuItems.ViewStyle := vsList;
end;

procedure TARMenuToolBar.V_OnReportButtonClick(Sender: TObject);
begin
	V_LTV_MenuItems.ViewStyle := vsReport;
end;

procedure TARMenuToolBar.V_OnSmallIconButtonClick(Sender: TObject);
begin
	V_LTV_MenuItems.ViewStyle := vsSmallIcon;

end;

procedure TARMenuToolBar.V_OnCloseButtonClick(Sender: TObject);
begin
	CloseMenu;
end;

procedure TARMenuToolBar.PSetV_DefMenuViewStyle(const Value: TViewStyle);
begin
	if Value <> V_DefMenuViewStyle then
		begin
			V_DefMenuViewStyle := Value;
		end;
end;
procedure TARMenuToolBar.PSetV_MenuViewStyleAction(const Value: TARMenuViewStyleAction);
begin
	if Value <> V_MenuViewStyleAction then
		begin
			V_MenuViewStyleAction := Value;
		end;
end;

procedure TARMenuToolBar.GradientFill(V_DestinationImage: TImage ; V_BeginColor: TColor; V_EndColor: TColor; V_GradientWidth: integer);
var
	V_Length 				: integer;
	V_Color					: TColor;

	X						: integer;

	R						: double;
	R1						: integer;
	R2						: integer;
	RStep					: double;

	G						: double;
	G1						: integer;
	G2						: integer;
	GStep					: double;

	B						: double;
	B1						: integer;
	B2						: integer;
	BStep					: double;

	RGBStr					: string;

	function GetRValue(V_Color: TColor):integer;
	var
		StringHex			: String;
	begin
		StringHex := IntToHex(ColorToRGB(V_Color),8);
		GetRValue := StrToIntDef('$' + Copy(StringHex,7,2),0);
	end;

	function GetGValue(V_Color: TColor):integer;
	var
		StringHex			: String;
	begin
		StringHex := IntToHex(ColorToRGB(V_Color),8);
		GetGValue := StrToIntDef('$' + Copy(StringHex,5,2),0);
	end;

	function GetBValue(V_Color: TColor):integer;
	var
		StringHex			: String;
	begin
		StringHex := IntToHex(ColorToRGB(V_Color),8);
		GetBValue := StrToIntDef('$' + Copy(StringHex,3,2),0);
	end;

begin
	V_Length := V_DestinationImage.Width;

	R1 := GetRValue(V_BeginColor);
	R2 := GetRValue(V_EndColor);
	RStep := (R2 - R1) / V_Length;

	G1 := GetGValue(V_BeginColor);
	G2 := GetGValue(V_EndColor);
	GStep := (G2 - G1) / V_Length;

	B1 := GetBValue(V_BeginColor);
	B2 := GetBValue(V_EndColor);
	BStep := (B2 - B1) / V_Length;


	R := R1;
	G := G1;
	B := B1;

	X := 0;
	V_GradientWidth := 1;
	repeat

		if R > 255 then
			R := 255;

		if R < 0 then
			R := 0;

		if G > 255 then
			G := 255;

		if G < 0 then
			G := 0;

		if B > 255 then
			B := 255;

		if B < 0 then
			B := 0;


		RGBStr := '$00'+IntToHex(round(B),2) + IntToHex(round(G),2) + IntToHex(round(R),2);
		V_Color := StrToInt(RGBStr);

		V_DestinationImage.Canvas.Pen.Color := V_Color;
		V_DestinationImage.Canvas.Brush.Color := V_Color;
		V_DestinationImage.Canvas.FillRect(Rect(X,0,X + V_GradientWidth,80));

		R := R + (V_GradientWidth * RStep);
		G := G + (V_GradientWidth * GStep);
		B := B + (V_GradientWidth * Bstep);

		X := X + V_GradientWidth;


	until X >= V_Length;


end;

procedure TARMenuToolBar.SetPageButtonImage(V_Button: TSpeedButton;V_ImageIndex: integer);
var
	V_BitMap					: TBitMap;
begin
	if V_ImageList = nil then
		begin
			V_Button.Glyph.FreeImage;
			exit;
		end;

	V_BitMap := TBitMap.Create;
	try
		V_ImageList.GetBitmap(V_ImageIndex,V_BitMap);
		V_Button.Glyph.Assign(V_BitMap);
	finally
		V_BitMap.Free;
	end;
end;

procedure TARMenuToolBar.Loaded;
var
	V_BitMap				: TBitMap;
	Counter					: integer;
	X,Y						: integer;

begin
	RefreshGlyphs;
	{Arrange Position of Closebutton and Width of ImageCaption that is relative to the Width of the MenuArea.. }
	{the V_MenuAreaWidthOpened is unavaiable at the Creation of the Object.. it is charged at Loaded}
	V_MenuCaption.Width := V_MenuAreaWidthOpened - 33 ;
	V_CloseButton.Left := V_MenuAreaWidthOpened - 26;

	{Assign the Button Images}
	V_Bitmap := TBitMap.Create;

	{Closebutton}
	V_BitMap.Height := V_CloseButtonImageHeight;
	V_BitMap.Width := V_CloseButtonImageWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1 do
		begin
			for y := 0 to V_BitMap.Height -1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_CloseButtonImage[Counter];
					inc(Counter);
				end;
		end;

	V_CloseButton.Glyph.Assign(V_BitMap);

	{ListButton}
	V_BitMap.Height := V_ListImageHeight;
	V_BitMap.Width := V_ListImageWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1 do
		begin
			for y := 0 to V_BitMap.Height -1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_ListImage[Counter];
					inc(Counter);
				end;
		end;

	V_ListButton.Glyph.Assign(V_BitMap);

	{ReportButton}
	V_BitMap.Height := V_ReportImageHeight;
	V_BitMap.Width := V_ReportImageWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1 do
		begin
			for y := 0 to V_BitMap.Height -1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_ReportImage[Counter];
					inc(Counter);
				end;
		end;

	V_ReportButton.Glyph.Assign(V_BitMap);

	{IconButton}
	V_BitMap.Height := V_IconImageHeight;
	V_BitMap.Width := V_IconImageWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1 do
		begin
			for y := 0 to V_BitMap.Height -1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_IconImage[Counter];
					inc(Counter);
				end;
		end;

	V_IconButton.Glyph.Assign(V_BitMap);		

	{SmallIconButton}
	V_BitMap.Height := V_SmallIconImageHeight;
	V_BitMap.Width := V_SmallIconImageWidth;
	Counter := 1;

	for x := 0 to V_BitMap.Width - 1 do
		begin
			for y := 0 to V_BitMap.Height -1 do
				begin
					V_BitMap.Canvas.Pixels[x,y] := V_SmallIconImage[Counter];
					inc(Counter);
				end;
		end;

	V_SmallIconButton.Glyph.Assign(V_BitMap);

	V_BitMap.Free;


	{ToolCaption}
	V_ToolCaption.Font.Assign(V_ToolCaptionFont);

	{ToolImage}
	V_ToolImage.Picture.Assign(V_ToolImagePicture);

	V_OwnerIsForm :=  Parent is TForm;

	V_Owner := Parent;

	inherited;
end;

procedure TARMenuToolBar.PSetV_MenuAreaWidthOpened(const Value: integer);
begin
	if (Value < 100) then
		begin
			if (csDesigning in ComponentState) then
				begin
					MessageDlg('Value must be greater than 99',mtError,[mbOk],0);
				end;
			exit;
		end;

	V_MenuAreaWidthOpened := Value;
end;
procedure TARMenuToolBar.PSetV_MenuAreaHeightOpened(const Value: integer);
begin
	if (Value < 140) then
		begin
			if (csDesigning in ComponentState) then
				begin
					MessageDlg('Value must greater than 139',mtError,[mbOk],0);
				end;
			exit;
		end;

	V_MenuAreaHeightOpened := Value;

end;

procedure TARMenuToolBar.ArrangeMenuButtons;
var
	PageNumber				: integer;
begin
	For PageNumber := 0 to V_MenuPages.Count - 1 do
		begin
			V_MenuPages.Items[PageNumber].V_PageArea.Align := alNone;
			V_MenuPages.Items[PageNumber].V_PageArea.Top := 1000;
		end;

	For PageNumber := 0 to V_MenuPages.Count - 1 do
		begin
			V_MenuPages.Items[PageNumber].V_PageArea.Align := alTop;
		end;

end;

procedure TARMenuToolBar.RefreshGlyphs;
var
	PageNumber		   		: integer;
begin
	For PageNumber := 0 to V_MenuPages.Count - 1 do
		begin
			if V_ImageList <> nil then
				begin
					SetPageButtonImage(V_MenuPages.Items[PageNumber].V_PageButton,V_MenuPages.Items[PageNumber].ImageIndex);
				end
			else
				begin
					V_MenuPages.Items[PageNumber].V_PageButton.Glyph.FreeImage;
				end;
		end;

end;
procedure TARMenuToolBar.SortV_LTV_MenuItems;
	 function V_SortAsc(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
	 begin
		Result := lstrcmp(PChar(TListItem(Item1).Caption),PChar(TListItem(Item2).Caption));
	 end;

	 function V_SortDesc(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
	 begin
		Result := -lstrcmp(PChar(TListItem(Item1).Caption),PChar(TListItem(Item2).Caption));
	 end;

begin

	case V_LTV_Sort of
		sort_Asc:
			begin
				V_LTV_MenuItems.CustomSort(@V_SortAsc, 0);
				if V_SortToogle then
					begin
						V_LTV_Sort := sort_Desc;
					end;
			end;
		sort_Desc:
			begin
				V_LTV_MenuItems.CustomSort(@V_SortDesc, 0);
				if V_SortToogle then
					begin
						V_LTV_Sort := sort_Asc;
					end;
			end;
	end;
end;

procedure TARMenuToolBar.V_LTV_MenuItemsOnColumnClick(Sender: TObject;Column: TListColumn);
begin
	SortV_LTV_MenuItems;
end;

procedure TARMenuToolBar.PSetV_LTV_Sort(const Value: TARLTV_Sort);
begin
	if Value <> V_LTV_Sort then
		begin
			V_LTV_Sort := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_SortToogle(const Value: boolean);
begin
	if Value <> V_SortToogle then
		begin
			V_SortToogle := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolCaptionBevelInner(const Value: TPanelBevel);
begin
	if Value <> V_ToolCaptionBevelInner then
		begin
			V_ToolCaptionBevelInner := Value;
			V_ToolCaption.BevelInner := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolCaptionBevelOuter(const Value: TPanelBevel);
begin
	if Value <> V_ToolCaptionBevelOuter then
		begin
			V_ToolCaptionBevelOuter := Value;
			V_ToolCaption.BevelOuter := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolCaptionBevelWidth(const Value: integer);
begin
	if Value <> V_ToolCaptionBevelWidth then
		begin
			V_ToolCaptionBevelWidth := Value;
			V_ToolCaption.BevelWidth := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolCaptionBorderStyle(const Value: TBorderStyle);
begin
	if Value <> V_ToolCaptionBorderStyle then
		begin
			V_ToolCaptionBorderStyle := Value;
			V_ToolCaption.BorderStyle := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolCaptionBorderWidth(const Value: integer);
begin
	if Value <> V_ToolCaptionBorderWidth then
		begin
			V_ToolCaptionBorderWidth := Value;
			V_ToolCaption.BorderWidth := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolCaptionHeight(const Value: integer);
begin
	if Value <> V_ToolCaptionHeight then
		begin
			V_ToolCaptionHeight := Value;
			V_ToolCaption.Height := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolCaptionAlignment(const Value: TAlignment);
begin
	if Value <> V_ToolCaptionAlignment then
		begin
			V_ToolCaptionAlignment := Value;
			V_ToolCaption.Alignment := Value;
		end;

end;

procedure TARMenuToolBar.PSetV_ToolCaptionCaption(const Value: string);
begin
	if Value <> V_ToolCaptionCaption then
		begin
			V_ToolCaptionCaption := Value;
			V_ToolCaption.Caption := Value;
		end;


end;

procedure TARMenuToolBar.PSetV_ToolCaptionColor(const Value: TColor);
begin
	if Value <> V_ToolCaptionColor then
		begin
			V_ToolCaptionColor := Value;
			V_ToolCaption.Color := Value;
		end;


end;
procedure TARMenuToolBar.PSetV_ToolCaptionFont(const Value: TFont);
begin
	V_ToolCaptionFont.Assign(Value);
	V_ToolCaption.Font.Assign(Value);
end;

procedure TARMenuToolBar.V_OnToolCaptionFontChange(Sender: TObject);
begin
	V_ToolCaption.Font.Assign(V_ToolCaptionFont);
end;
procedure TARMenuToolBar.PSetV_MenuAnimation(const Value: boolean);
begin
	if Value <> V_MenuAnimation then
		begin
			V_MenuAnimation := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_MenuCloseAnimationSteps(const Value: integer);
begin
	if (Value < 1) OR (Value > 500) then
		begin
			if csDesigning in ComponentState then
				begin
					MessageDlg('Value must be between 1 and 500',mtError,[mbOk],0);
				end;
			exit;
		end;

	if Value <> V_MenuCloseAnimationSteps then
		begin
			V_MenuCloseAnimationSteps := Value;
		end;

end;

procedure TARMenuToolBar.PSetV_MenuOpenAnimationSteps(const Value: integer);
begin
	if (Value < 1) OR (Value > 200) then
		begin
			if csDesigning in ComponentState then
				begin
					MessageDlg('Value must be between 1 and 200',mtError,[mbOk],0);
				end;
			exit;
		end;

	if Value <> V_MenuOpenAnimationSteps then
		begin
			V_MenuOpenAnimationSteps := Value;
		end;

end;
procedure TARMenuToolBar.PSetV_MenuPopupPosition(const Value: TARMenuPopUpPosition);
begin
	if V_MenuStatus = men_Opened then
		begin
			if V_MenuPopUpPosition <> Value then
				begin
					CloseMenu;
					V_MenuPopUpPosition := Value;
					OpenMenu;
				end;
		end
	else
		begin
			if V_MenuPopUpPosition <> Value then
				begin
					V_MenuPopUpPosition := Value;
				end;
		end;
end;
procedure TARMenuToolBar.PSetV_ButtonAreaColor(const Value: TColor);
begin
	if Value <> V_ButtonAreaColor then
		begin
			V_ButtonAreaColor := Value;
			V_ButtonArea.Color := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolImageCenter(const Value: boolean);
begin
	if Value <> V_ToolImageCenter then
		begin
			V_ToolImageCenter := Value;
			V_ToolImage.Center := Value;
		end;
end;

procedure TARMenuToolBar.PSetV_ToolImageHeight(const Value: integer);
begin
	if Value <> V_ToolImageHeight then
		begin
			V_ToolImageHeight := Value;
			V_ToolImagePanel.Height := Value;
		end;

end;

procedure TARMenuToolBar.PSetV_ToolImagePicture(const Value: TPicture);
begin
	V_ToolImagePicture.Assign(Value);
	V_ToolImage.Picture.Assign(Value);
end;

procedure TARMenuToolBar.PSetV_ToolImageStretch(const Value: boolean);
begin
	if Value <> V_ToolImageStretch then
		begin
			V_ToolImageStretch := Value;
			V_ToolImage.Stretch := Value;
		end;


end;

procedure TARMenuToolBar.PSetV_ToolImageTransparent(const Value: boolean);
begin
	if Value <> V_ToolImageTransparent then
		begin
			V_ToolImageTransparent := Value;
			V_ToolImage.Transparent := Value;
		end;


end;

procedure TARMenuToolBar.PSetV_ToolImageVisible(const Value: boolean);
begin
	if Value <> V_ToolImageVisible then
		begin
			V_ToolImageVisible := Value;
			V_ToolImage.Visible := Value;
		end;


end;

(*
	
																																										
			   																T A R M E N U  P A G E 	  																	
																																										
	

*)





{ TARMenuPage }

constructor TARMenuPage.Create(Collection: TCollection);
begin
	inherited Create(Collection);
	V_Owner := TARMenuPages(Collection);

	V_PageArea := TPanel.Create(V_Owner.ARMenuToolBar);
	V_PageArea.Parent := V_Owner.ARMenuToolBar.V_ButtonArea;
	V_PageArea.Height := 34;
	V_PageArea.Align := alTop;
	V_PageArea.BevelInner := bvNone;
	V_PAgeArea.BevelOuter := bvNone;
	V_PAgeArea.BorderStyle := bsNone;
	V_PageArea.OnResize := V_PageAreaOnResize;
	V_MenuStripHeight := V_PageArea.Height;
	V_MenuStripColor := V_PageArea.Color;


	V_PageButton := TSpeedButton.Create(V_PageArea);
	V_PageButton.Parent := V_PageArea;
	V_PageButton.Width := V_PageArea.Width - 2;
	V_PageButton.Height := V_PageArea.Height - 2;
	V_PageButton.Caption := MenuCaption;
	V_PageButton.Top := 2;
	V_PageButton.Left := 2;
	V_PageButton.Flat := True;
	V_PageButton.OnClick := V_OnPageButtonClick;
	V_PageButton.Spacing := 4;
	V_PageButton.Layout := blGlyphTop;
	V_PageButton.Cursor := crHandPoint;


	V_PageButtonSpacing := V_PageButton.Spacing;
	V_PageButtonLayout := V_PageButton.Layout;
	V_PageButtonCursor := V_PageButton.Cursor;

	V_ImageIndex := -1;


	V_PageButtonFlat := True;
	V_PageButton.ShowHint := False;
	V_PageButton.ParentShowHint := True;
	V_PageButton.Hint := '';
	V_PageButtonHint := '';
	V_PageButton.Enabled := True;
	V_PageButtonEnabled := True;

	{MenuFont}
	V_MenuFont := TFont.Create;
	V_Menufont.OnChange := V_OnMenuFontChange;

	{MenuColor}
	V_MenuColor := clWindow;

	{Gradient Settings}
	V_MenuCaptionBeginColor := clBtnShadow;
	V_MenuCaptionEndColor := clWindow;
	V_MenuGradientWidth := 1;

	{MenuItems Property}
	V_ARMenuItems := TARMenuItems.Create(Self);

end;

destructor TARMenuPage.Destroy;
begin
	{Free Events}
	V_PageArea.OnResize := nil;
	V_PageButton.OnClick := nil;

	{Free Internal Objects}
	V_PageButton.Free;
	V_PageArea.Free;

	{Free the Font}
	V_MenuFont.OnChange := nil;
	V_MenuFont.Free;
	
	{Free the MenuItems}
	V_ARMenuItems.Free;

	inherited Destroy;
end;

procedure TARMenuPage.Assign(Source: TPersistent);
begin
	inherited Assign(Source);
end;

procedure TARMenuPage.DefineProperties(Filer: TFiler);
begin
	inherited DefineProperties(Filer);
end;


function TARMenuPage.GetDisplayName: string;
begin
	if V_MenuCaption = '' then
		begin
			GetDisplayName := inherited GetDisplayName;
		end
	else
		begin
			GetDisplayName := V_MenuCaption;
		end;

end;

procedure TARMenuPage.PSetV_MenuCaption(const Value: string);
begin
	if Value <> V_MenuCaption then
		begin
			V_MenuCaption := Value;
			V_PageButton.Caption := Value;
		end;
end;

procedure TARMenuPage.V_PageAreaOnResize(Sender: TObject);
begin
	V_PageButton.Width := V_PageArea.Width - 2;
	V_PageButton.Height := V_PageArea.Height - 2;
end;


procedure TARMenuPage.PSetV_PageButtonFlat(const Value: boolean);
begin
	if Value <> V_PageButtonFlat then
		begin
			V_PageButtonFlat := Value;
			V_PageButton.Flat := Value;
		end;
end;

procedure TARMenuPage.V_OnPageButtonClick(Sender: TObject);
begin
	{Inform the Main Object wich menu was pressed}
	V_Owner.ARMenuToolBar.MenuButtonNotification(Self);
end;
procedure TARMenuPage.PSetV_ARMenuItems(const Value: TARMenuItems);
begin
	V_ARMenuItems.Assign(Value);
end;
procedure TARMenuPage.PSetV_MenuFont(const Value: TFont);
begin
	V_MenuFont.Assign(Value);
end;

procedure TARMenuPage.PSetV_MenuColor(const Value: TColor);
begin
	if V_MenuColor <> Value then
		begin
			V_MenuColor := Value;
		end;
end;
procedure TARMenuPage.PSetV_MenuCaptionBeginColor(const Value: TColor);
begin
	if Value <> V_MenuCaptionBeginColor then
		begin
			V_MenuCaptionBeginColor := Value;
		end;
end;

procedure TARMenuPage.PSetV_MenuCaptionEndColor(const Value: TColor);
begin
	if Value <> V_MenuCaptionEndColor then
		begin
			V_MenuCaptionEndColor := Value;
		end;

end;

procedure TARMenuPage.PSetV_MenuGradientWidth(const Value: integer);
begin
	if (Value < 1) or (Value > 10) then
		begin
			if csDesigning in V_Owner.ARMenuToolBar.ComponentState then
				begin
					MessageDlg('Value must be beetween 1 and 10',mtError,[mbOk],0);
				end;
			exit;
		end;

	if Value <> V_MenuGradientWidth then
		begin
			V_MenuGradientWidth := Value;
		end;

end;
procedure TARMenuPage.PSetV_MenuStripHeight(const Value: integer);
begin
	if Value < 10 then
		exit;

	if Value <> V_MenuStripHeight then
		begin
			V_MenuStripHeight := Value;
			V_PageArea.Height := Value;
		end;
end;

procedure TARMenuPage.PSetV_ImageIndex(const Value: integer);
begin
	V_ImageIndex := Value;
	V_Owner.ARMenuToolBar.SetPageButtonImage(V_PageButton,Value);
end;

procedure TARMenuPage.PSetV_PageButtonLayout(const Value: TButtonLayout);
begin
	if Value <> V_PageButtonLayout then
		begin
			V_PageButtonLayout := Value;
			V_PageButton.Layout := Value;
		end;
end;

procedure TARMenuPage.PSetV_PageButtonSpacing(const Value: integer);
begin
	if Value <> V_PageButtonSpacing then
		begin
			V_PageButtonSpacing := Value;
		    V_PageButton.Spacing := Value;
		end;

end;

procedure TARMenuPage.PSetV_PageButtonHint(const Value: string);
begin
	if Value <> V_PageButtonHint then
		begin
			V_PageButtonHint := Value;
			V_PageButton.Hint := Value;
		end;
end;
procedure TARMenuPage.PSetV_PageButtonEnabled(const Value: boolean);
begin
	if Value <> V_PageButtonEnabled then
		begin
			V_PageButtonEnabled := Value;
			V_PageButton.Enabled := Value;
		end;
end;

procedure TARMenuPage.PSetV_PageButtonParentShowHint(const Value: boolean);
begin
	if Value <> V_PageButtonParentShowHint then
		begin
			V_PageButtonParentShowHint := Value;
			V_PageButton.ParentShowHint := Value;
			V_PageButtonShowHint := V_PageButton.ShowHint;
		end;
end;

procedure TARMenuPage.PSetV_PageButtonShowHint(const Value: boolean);
begin
	if Value <> V_PageButtonShowHint then
		begin
			V_PageButtonShowHint := Value;
			V_PageButton.ShowHint := Value;
			V_PageButtonParentShowHint := V_PageButton.ParentShowHint;
		end;

end;

procedure TARMenuPage.V_OnMenuFontChange(Sender: TObject);
begin
	V_PageButton.Font.Assign(V_MenuFont);
end;
procedure TARMenuPage.PSetV_PageButtonCursor(const Value: TCursor);
begin
	if Value <> V_PageButtonCursor then
		begin
			V_PageButtonCursor := Value;
			V_PageButton.Cursor := Value;
		end;

end;

procedure TARMenuPage.PSetV_MenuStripColor(const Value: TColor);
begin
	if Value <> V_MenuStripColor then
		begin
			V_MenuStripColor := Value;
			V_PageArea.Color := VAlue;
		end;
end;

(*
	
																																										
			   																E N D  O F  T A R M E N U  P A G E 	 														
																																										
	

*)
(*
	
																																										
			   																T A R M E N U  P A G E S   																	
																																										
	

*)


{ TARMenuPages }

constructor TARMenuPages.Create(AOwner: TARMenuToolBar);
begin
	inherited Create(TARMenuPage);
	V_Owner := AOwner;
end;

destructor TARMenuPages.Destroy;
begin
	inherited Destroy;
end;

function TARMenuPages.GetItem(Index: Integer): TARMenuPage;
begin
	Result := TARMenuPage(inherited GetItem(Index));
end;
procedure TARMenuPages.SetItem(Index: Integer; Value: TARMenuPage);
begin
	inherited SetItem(Index, Value);
end;


function TARMenuPages.GetOwner: TPersistent;
begin
	Result := V_Owner;
end;

function TARMenuPages.Add: TARMenuPage;
begin
	Result := TARMenuPage(inherited Add);
end;

procedure TARMenuPages.Update(Item: TCollectionItem);
begin
	ARMenuToolBar.ArrangeMenuButtons;
end;

(*
	
																																										
			   																E N D  O F  T A R M E N U  P A G E S  														
																																										
	

*)
(*
	
																																										
			   																 T A R M E N U I T E M   	 	 															
																																										
	

*)

{ TARMenuItem }

constructor TARMenuItem.Create(Collection: TCollection);
begin
	inherited Create(Collection);

	{Store the Owner for internal use}
	V_Owner := TARMenuItems(Collection);

	{Variables}
	V_CloseMenuOnAction := True;
	V_ImageIndex := -1;
	V_StateIndex := -1;
	V_ItemEnabled := True;
end;

destructor TARMenuItem.Destroy;
begin

	inherited Destroy;
end;

procedure TARMenuItem.Assign(Source: TPersistent);
begin
	inherited Assign(Source);
end;

procedure TARMenuItem.DefineProperties(Filer: TFiler);
begin
	inherited DefineProperties(Filer);
end;


function TARMenuItem.GetDisplayName: string;
begin
	if V_ItemCaption = '' then
		begin
			GetDisplayName := inherited GetDisplayName;
		end
	else
		begin
			GetDisplayName := V_ItemCaption;
		end;

end;
procedure TARMenuItem.PSetV_ItemCaption(const Value: string);
begin
	if Value <> V_ItemCaption then
		begin
			V_ItemCaption := Value;
		end;
end;
procedure TARMenuItem.PSetV_CloseMenuOnAction(const Value: boolean);
begin
	if Value <> V_CloseMenuOnAction then
		begin
			V_CloseMenuOnAction := Value;
		end;
end;
procedure TARMenuItem.PSetV_ImageIndex(const Value: integer);
begin
	if Value <> V_ImageIndex then
		begin
			V_ImageIndex := Value;
		end;

end;
procedure TARMenuItem.PSetV_StateIndex(const Value: integer);
begin
	if Value <> V_StateIndex then
		begin
			V_StateIndex := Value;
		end;
end;

procedure TARMenuItem.PSetV_ItemEnabled(const Value: boolean);
begin
	if Value <> V_ItemEnabled then
		begin
			V_ItemEnabled := Value;
		end;
end;

(*
	
																																										
			   																E N D  O F  T A R M E N U  I T E M 															
																																										
	

*)
(*
	
																																										
			   																T A R M E N U I T E M S																		
																																										
	

*)



{ TARMenuItems }

constructor TARMenuItems.Create(AOwner: TARMenuPage);
begin
	inherited Create(TARMenuItem);
	V_Owner := AOwner;
end;

destructor TARMenuItems.Destroy;
begin
	inherited Destroy;
end;

function TARMenuItems.GetItem(Index: Integer): TARMenuItem;
begin
	Result := TARMenuItem(inherited GetItem(Index));
end;
procedure TARMenuItems.SetItem(Index: Integer; Value: TARMenuItem);
begin
	inherited SetItem(Index, Value);
end;


function TARMenuItems.GetOwner: TPersistent;
begin
	Result := V_Owner;
end;

function TARMenuItems.Add: TARMenuItem;
begin
	Result := TARMenuItem(inherited Add);
end;

procedure TARMenuItems.Update(Item: TCollectionItem);
begin
//
end;

(*
	
																																										
			   																E N D  O F  T A R M E N U I T E M S															
																																										
	

*)
procedure TAboutProperty.Edit;
var
	VForm				: TForm;
	VButton				: TButton;
	VLabel				: TLabel;
	VLabel1				: TLAbel;
	VLabel2				: TLAbel;
	VImage				: TImage;

	Counter				: integer;
	x,y					: integer;
begin
	VForm := TForm.Create(nil);
	VButton := TButton.Create(VForm);
	VLabel := TLabel.Create(VForm);
	VLabel1 := TLAbel.Create(VForm);
	VLabel2 := TLAbel.Create(VForm);
	VImage := TImage.Create(VForm);

	VButton.Width := 60;
	VButton.Height := 21;
	VButton.Left := 126;
	VButton.Top := 120;
	VButton.Caption := 'Ok';
	VButton.ModalResult := mrOk;
	Vbutton.Parent := VForm;

	VLabel.Width := 252;
	VLabel.Height := 205;
	VLabel.Left := 64;
	VLabel.Top := 4;
	VLabel.AutoSize := False;
	VLabel.Caption := 'ARMenuToolBar V1.0. A Different ToolBar ! Now '+#10
					 +'More ''things'' in less Space !'+#10
					 +#10#10+'E-Mail:'+#10#10+'WWW:';
	VLabel1.Left := 100;
	VLabel1.Top := 56;
	VLabel1.Font.Color := clBlue;
	VLabel1.Font.Style := [fsUnderline];		

	VLabel2.Left := 100;
	VLabel2.Top := 82;
	VLabel2.Font.Color := clBlue;
	VLabel2.Font.Style := [fsUnderline];

	VLabel1.Caption := 'albertrs@redestb.es';

	VLabel2.Caption := 'http://personal.redestb.es/albertrs';

	VLabel.Parent := VForm;
	VLabel1.Parent := VForm;
	VLabel2.Parent := VForm;
	VImage.Parent := VForm;
	VImage.Transparent := True;

	VImage.Top := 10;
	VImage.Left := 10;


	Counter := 1;
	VImage.Picture.BitMap.Height := V_AlbertResearchHeight;
	VImage.Picture.BitMap.Width := V_AlbertResearchWidth;	

	for x := 0 to VImage.Picture.BitMap.Width - 1 do
		begin
			for y := 0 to VImage.Picture.BitMap.Height - 1 do
				begin
					VImage.Picture.BitMap.Canvas.Pixels[x,y] := V_AlbertResearch[Counter];
					inc(Counter);
				end;
		end;


	VForm.BorderStyle := bsToolWindow;
	VForm.Width := 324;
	VForm.Height := 170;
	VForm.Position := poScreenCenter;
	VForm.Caption := 'Albert Research 98 ARMenuToolBar V1.0';
	VForm.ShowModal;

end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
	Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
	Result := 'Albert Research 98';
end;


end.
